<template>
  <div class='airTable'>
    <div class="box-list">
      <div v-for="(item, index) in tableData">
        <template :ref="`item${ index }`" v-for='listItem in item.list'>
          <div class="box-list-tr box-list-title setHeight" v-if='listItem.title != ""'>
            <p :style="{ 'background': listItem.color, 'fontSize': '24px' }">{{ listItem.title }}</p>
          </div>
          <div :class="['box-list-tr', 'box-list-th', isSub ? '' : 'getHeight']"
            :style="{ marginBottom: listItem.list.length === 0 ? '12px' : '0', height: index == 0 ? firstHei + 'px' : index == 1 ? secondHei + 'px' : threeHei + 'px' }">
            <p v-for='tableItem in tableColumn'>{{ tableItem.label }}</p>
          </div>
          <div :class="['box-list-tr', 'box-list-bg', isSub ? '' : 'getHeight']" @click="handleDetail(item2)"
            :style="{ marginBottom: index2 === listItem.list.length - 1 ? '12px' : '0', height: index == 0 ? firstHei + 'px' : index == 1 ? secondHei + 'px' : threeHei + 'px' }"
            v-for="(item2, index2) in listItem.list">
            <p class="box-list-qx" v-for='tableItem in tableColumn'>{{ item2[tableItem.prop] || '0' }}</p>
          </div>
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import $ from 'jquery'

export default {
  name: "list",
  props: {
    data: {
      type: Array,
      default: function () {
        return []
      }
    },
    tableColumn: {
      type: Array,
      default: function () {
        return []
      }
    },
    lsFd: {
      type: Object,
      default: function () {
        // return { A: true, B: true, C: true, D: true, E: true }
        return { A: true, B: true, C: true, D: true }
      }
    },
    isFirm: {
      type: Boolean,
      default: false
    },
    isSub: {
      type: Boolean,
      default: true
    }
  },
  watch: {
    data: {
      handler(nv, ov) {
        this.$nextTick(() => {
          this.initTableData(nv)
        })
      },
      immediate: true
    }
  },
  mounted() {

  },
  data() {
    return {
      tableData: [],
      tapHei: 32,//档类标题高度
      tableHeadHei: 32,//表头高度
      maxColLen: 17, //每列最大长度
      firstLen: 0,//首列长度
      secondLen: 0,//第二列长度
      threeLen: 0,//第三列长度
      firstHei: 0,//首列行高
      secondHei: 0,//第二列行高
      threeHei: 0,//第三列行高
      mainHeight: 0
    }
  },
  // mounted() {
  //   // this.initTableData(this.data)

  // },
  methods: {
    initTableData(data) {
      let { comp } = this.$route.query
      let { year, quarter } = JSON.parse(sessionStorage.getItem('searchDate'))
      if (data.length == 0) {
        return
      }
      this.tableData = []
      let taps = ['A', 'B', 'C', 'D', 'E']
      // let taps = ['A', 'B', 'C', 'D']
      // 绿色：#20A367 蓝色：#3877B2 黄色：#E3C428 橙色：#E49317 红色：#B04332
      // let colors = ['rgb(57, 140, 143)', 'rgb(25, 112, 193)', 'rgb(163, 163, 85)', 'rgb(176, 130, 92)', 'rgb(155, 78, 85)']
      let colors = ['#20A367', '#3877B2', '#E3C428', '#E49317', '#B04332']
      let temp = {};
      for (let i = 0; i < 3; i++) {
        temp = {
          col: i + 1,
          list: []
        }
        this.tableData.push(temp)
      }
      let dataLen = 0
      data.forEach((item, index) => {
        if (this.lsFd[taps[index]]) {
          dataLen += item.length + 2
        }
      })
      this.tableData.forEach((tableItem, tableIndex) => {
        let tempLen = 0
        let colLen = this.isFirm ? 16 : Math.ceil(dataLen / 3)

        if (tableItem.col === 1) {
          data.forEach((item, index) => {
            if (item.length > 0 && ((tempLen + item.length + 2) < colLen + 1) || ((tempLen + item.length + 2) === colLen + 1)) {
              this.pushData(1, taps[index], item, colors[index], taps[index])
              tempLen += item.length + 2
            } else if (item.length > 0 && (tempLen + item.length + 2) > colLen) {
              let overLen = colLen - tempLen
              if (tempLen > 0 && overLen > 2) {
                this.pushData(1, taps[index], item.slice(0, (overLen - 2)), colors[index], taps[index])
                tempLen += overLen
              } else if (tempLen > 0 && overLen < 3 && overLen > 0) {
                this.pushData(1, taps[index], item.slice(0, 1), colors[index], taps[index])
                tempLen += 3
              } else if (tempLen === 0 && (tempLen + item.length + 2) > colLen + 1) {
                this.pushData(1, taps[index], item.slice(0, colLen - 2), colors[index], taps[index])
                tempLen += colLen
              }
            } else if (item.length === 0 && this.lsFd[taps[index]] && (tempLen + item.length + 2) <= colLen) {
              this.pushData(1, taps[index], [], colors[index], taps[index])
              tempLen += item.length + 2
            }
          })
        } else if (tableItem.col === 2) {
          tempLen = 0
          colLen = 0
          this.tableData[0].list.forEach(item => {
            colLen += item.list.length + 2
          })
          let dataIndex = taps.indexOf(this.tableData[0].list[this.tableData[0].list.length - 1].dc)
          if (data[dataIndex].length === this.tableData[0].list[this.tableData[0].list.length - 1].list.length) {
            data.forEach((item, index) => {
              if (index > dataIndex) {
                if (item.length > 0 && ((tempLen + item.length + 2) < colLen + 1) || ((tempLen + item.length + 2) === colLen + 1)) {
                  this.pushData(2, taps[index], item, colors[index], taps[index])
                  tempLen += item.length + 2
                } else if (item.length > 0 && (tempLen + item.length + 2) > colLen) {
                  let overLen = colLen - tempLen
                  if (tempLen > 0 && overLen > 2) {
                    this.pushData(2, taps[index], item.slice(0, (overLen - 2)), colors[index], taps[index])
                    tempLen += overLen
                  } else if (tempLen > 0 && overLen < 3 && overLen > 0) {
                    this.pushData(2, taps[index], item.slice(0, 1), colors[index], taps[index])
                    tempLen += 3
                  } else if (tempLen === 0 && (tempLen + item.length + 2) > colLen + 1) {
                    this.pushData(2, taps[index], item.slice(0, colLen - 2), colors[index], taps[index])
                    tempLen += colLen
                  }
                } else if (item.length === 0 && this.lsFd[taps[index]] && (tempLen + item.length + 2) <= colLen) {
                  this.pushData(2, taps[index], [], colors[index], taps[index])
                  tempLen += item.length + 2
                }
              }
            })
          } else {
            data.forEach((item, index) => {
              if (index === dataIndex) {
                let lastIndex = 0
                this.tableData[0].list[this.tableData[0].list.length - 1].list.forEach(lItem => {
                  lastIndex = item.indexOf(lItem) + 1
                })
                let overLen = item.length - lastIndex
                if (((tempLen + overLen + 1) < colLen + 1) || ((tempLen + overLen + 1) === colLen + 1)) {
                  this.pushData(2, '', item.slice(lastIndex, item.length), colors[index], taps[index])
                  tempLen += overLen + 1
                } else if (item.length > 0 && (tempLen + overLen + 1) > colLen) {
                  this.pushData(2, '', item.slice(lastIndex, (this.tableData[0].list[this.tableData[0].list.length - 1].list.length + colLen - 1)), colors[index], taps[dataIndex])
                  tempLen += colLen
                }
              } else if (index > dataIndex) {
                if (item.length > 0 && ((tempLen + item.length + 2) < colLen + 1) || ((tempLen + item.length + 2) === colLen + 1)) {
                  this.pushData(2, taps[index], item, colors[index], taps[index])
                  tempLen += item.length + 2
                } else if (item.length > 0 && (tempLen + item.length + 2) > colLen) {
                  let overLen = colLen - tempLen
                  if (tempLen > 0 && overLen > 2) {
                    this.pushData(2, taps[index], item.slice(0, (overLen - 2)), colors[index], taps[index])
                    tempLen += overLen
                  } else if (tempLen > 0 && overLen < 3 && overLen > 0) {
                    this.pushData(2, taps[index], item.slice(0, 1), colors[index], taps[index])
                    tempLen += 3
                  } else if (tempLen === 0 && (tempLen + item.length + 2) > colLen + 1) {
                    this.pushData(2, taps[index], item.slice(0, colLen - 2), colors[index], taps[index])
                    tempLen += colLen
                  }
                } else if (item.length === 0 && this.lsFd[taps[index]] && (tempLen + item.length + 2) <= colLen) {
                  this.pushData(2, taps[index], [], colors[index], taps[index])
                  tempLen += item.length + 2
                }
              }
            })
          }
        } else if (tableItem.col === 3) {
          tempLen = 0
          let dataIndex = taps.indexOf(this.tableData[1].list[this.tableData[1].list.length - 1].dc)

          if (data[dataIndex].length === this.tableData[1].list[this.tableData[1].list.length - 1].list.length) {
            data.forEach((item, index) => {
              if (item.length > 0 && index > dataIndex) {
                this.pushData(3, taps[index], item, colors[index], taps[index])
              } else if (item.length === 0 && this.lsFd[taps[index]]) {
                this.pushData(3, taps[index], [], colors[index], taps[index])
              }
            })
          } else {
            data.forEach((item, index) => {
              if (index === dataIndex) {
                let lastIndex = 0
                this.tableData[1].list[this.tableData[1].list.length - 1].list.forEach(lItem => {
                  lastIndex = item.indexOf(lItem) + 1
                })
                if (lastIndex < item.length) {
                  this.pushData(3, '', item.slice(lastIndex, item.length), '', taps[dataIndex])
                }
              } else if (index > dataIndex) {
                if (item.length > 0) {
                  this.pushData(3, taps[index], item, colors[index], taps[index])
                } else if (item.length === 0 && this.lsFd[taps[index]]) {
                  this.pushData(3, taps[index], [], colors[index], taps[index])
                }
              }
            })
          }
        }

      })
      this.firstLen = 0
      this.secondLen = 0
      this.threeLen = 0
      this.firstHei = 0
      this.secondHei = 0
      this.threeHei = 0
      this.mainHeight = $('.airTable').height()
      this.tableData.forEach((item, index) => {
        if (index === 0) {
          let fds = 0
          item.list.forEach((citem, cindex) => {
            fds++
            this.firstLen += citem.list.length + 1
          })
          this.firstHei = (this.mainHeight - fds * 32 - (fds - 1) * 12) / this.firstLen
        } else if (index === 1) {
          let fds = 0
          let jgs = 0
          item.list.forEach((citem, cindex) => {
            jgs++
            if (citem.title !== '') {
              fds++
            }
            this.secondLen += citem.list.length + 1
          })
          this.secondHei = (this.mainHeight - fds * 32 - (jgs - 1) * 12) / this.secondLen
        } else if (index === 2) {
          let fds = 0
          let jgs = 0
          item.list.forEach((citem, cindex) => {
            jgs++
            if (citem.title !== '') {
              fds++
            }
            this.threeLen += citem.list.length + 1
          })
          this.threeHei = (this.mainHeight - fds * 32 - (jgs - 1) * 12) / this.threeLen
        }

      })
      this.$nextTick(() => {
        let getHeights = document.querySelectorAll('.getHeight')
        getHeights.forEach((item, index) => {
          if (index < 14 || 43 < index < 58) {
            // item.style.height = getHeights[getHeights.length - 1].style.height
            item.style.setProperty('height', getHeights[getHeights.length - 1].style.height, 'important');
          }
        })
        this.$emit('loadComplete')
      })
    },
    pushData(col, title, list, color, dc) {
      let temp1 = {
        title: title,
        list: list,
        color: color,
        dc: dc
      }
      this.tableData.forEach(item => {
        if (item.col === col) {
          item.list.push(temp1)
        }
      })

    },
    handleDetail(unitInfo) {
      let { comp } = this.$route.query
      let { unitName, unitCode } = unitInfo
      let tem = comp == "mapTarget_1" || comp == "mapTarget_2" || comp == "mapTarget_4" ? 'reformPilot' :
        comp == "mapTarget_5" || comp == "mapTarget_6" ? 'brandDetail' : ''
      if (tem == 'reformPilot') {
        this.$router.push({
          path: '/DetailComponent',
          name: 'DetailComponent',
          query: {
            unitName,
            unitCode,
            comp: tem,
            type: '1',
            numType: comp == "mapTarget_1" ? 'nationalNum' : 'nationalAddNum'
          }
        })
      } else if (tem == 'brandDetail' && comp != 'mapTarget_8') {
        this.$router.push({
          path: '/DetailComponent',
          name: 'DetailComponent',
          query: {
            comp: tem,
            code: unitCode,
            type: comp == "mapTarget_5" ? '1' : comp == "mapTarget_6" ? '2' : comp == "mapTarget_7" ? '3' : '',
            title: '品牌创建·' + unitName,
          },
        })
      }

    },
  }
}
</script>

<style scoped lang="scss">
.airTable {
  width: 100%;
  height: 100%;
  //padding: 0 24px;
  box-sizing: border-box;
}

.box-list {
  display: flex;
  align-items: center;
  justify-content: space-between;

  &>div {
    width: calc(100% / 3 - 48px / 3);
  }

  //-webkit-column-count: 3; /* Chrome, Safari, Opera */
  //-moz-column-count: 3; /* Firefox */
  //column-count: 3;
  //-webkit-column-gap: 24px; /* Chrome, Safari, Opera */
  //-moz-column-gap: 24px; /* Firefox */
  //column-gap: 24px;
  background-color: #072d62;

  div {
    height: 40PX;
    line-height: 40PX;
    text-align: center;
    color: #fff;
  }

  .box-list-tr.box-list-th {

    //height: 32px;
    //line-height: 32px;
    p {
      font-size: 16PX;
      white-space: nowrap;
    }

    :nth-child(2),
    :nth-child(3) {
      flex: 2;
    }

    :nth-child(4) {
      flex: 1.5;
    }
  }

  .box-list-title {
    height: 32PX;

    p {
      height: 32PX;
      line-height: 30PX;
      color: #fff;
      //font-size: 26px;
      margin-top: 12PX;
    }
  }

  .box-list-tr {
    display: flex;
    align-items: center;
    justify-content: center;

    p {
      margin: 0;
      flex: 1;
      font-size: 17PX;
      white-space: nowrap;
    }

    :nth-child(2),
    :nth-child(3) {
      flex: 2;
    }

    :nth-child(4) {
      flex: 1.5;
    }

  }

  .box-list-qx {
    color: #ffffff;
    white-space: nowrap;
  }

  .box-list-bg {
    cursor: pointer;
    background-color: #0e356a;

    &:nth-child(2n+1) {
      background-color: #143c72;
    }
  }
}
</style>